<script setup lang="ts">
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import { storeToRefs } from 'pinia'
    import { ref } from 'vue'
    import { useDisplay } from 'vuetify'
    import {
        useInventoryConfigurationStore,
        inventoryConfigurationStoreName,
    } from '../stores/InventoryConfigurationStore'
    import { requiredInject } from '@/shared/helpers/types'
    import { useStoreKeys } from '@/shared/user/composables/useStoreKeys'
    import { useMsal } from '@/plugins/msal/useMsal'

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const codeArticle = ref<string>('')
    const { mdAndUp } = useDisplay()

    const { generateUserServiceOfferScopedStoreKey } = useStoreKeys(useMsal())

    const { codeArticlePrefix } = storeToRefs(
        useInventoryConfigurationStore(
            generateUserServiceOfferScopedStoreKey(
                inventoryConfigurationStoreName,
                serviceOfferId.value
            )
        )
    )
    const displayInputConfigurationDialog = ref(false)
</script>
<template>
    <v-form
        @submit.prevent="
            $router.push({
                name: 'logistic-service-offer/inventaire/inventorier',
                params: {
                    serviceOfferId,
                    codeArticle: codeArticlePrefix + codeArticle,
                },
            })
        "
    >
        <v-card>
            <v-card-title> Scannez ou saisissez un code article </v-card-title>
            <div class="d-flex">
                <v-card-text>
                    <v-text-field
                        v-model="codeArticle"
                        style="min-width: 200px"
                        :prefix="codeArticlePrefix"
                        :prepend-inner-icon="
                            codeArticlePrefix === ''
                                ? 'mdi-barcode-scan'
                                : 'mdi-barcode-off'
                        "
                        append-inner-icon="mdi-cog-outline"
                        label="Code article"
                        autofocus
                        data-cy="champ-de-saisie-de-code-article"
                        autocapitalize="characters"
                        hide-details="auto"
                        :hint="
                            codeArticlePrefix === ''
                                ? undefined
                                : 'L\'utilisation d\'un préfixe est incompatible avec l\'usage d\'un scanneur de codes-barres'
                        "
                        @click:append-inner="
                            () => {
                                displayInputConfigurationDialog =
                                    !displayInputConfigurationDialog
                            }
                        "
                    >
                    </v-text-field>
                </v-card-text>
                <s-action-button
                    v-if="mdAndUp"
                    class="ma-4"
                    :disabled="codeArticle === ''"
                    data-cy="btn-inventorier"
                    size="x-large"
                    type="submit"
                >
                    Inventorier
                </s-action-button>
            </div>
            <v-divider v-if="!mdAndUp"></v-divider>
            <v-card-actions v-if="!mdAndUp">
                <v-spacer></v-spacer>
                <s-action-button
                    :disabled="codeArticle === ''"
                    data-cy="btn-inventorier"
                    size="x-large"
                    type="submit"
                >
                    Inventorier
                </s-action-button>
            </v-card-actions>
        </v-card>
    </v-form>
    <v-dialog v-model="displayInputConfigurationDialog" width="500">
        <v-form @submit.prevent="displayInputConfigurationDialog = false">
            <v-card>
                <v-card-title>
                    <span class="text-h5">Paramètres de saisie</span>
                </v-card-title>
                <v-card-text>
                    <v-container>
                        <v-text-field
                            v-model="codeArticlePrefix"
                            data-cy="codearticle-prefix-input"
                            label="Préfixe des codes article"
                            required
                        >
                        </v-text-field>
                    </v-container>
                </v-card-text>
                <v-divider></v-divider>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <s-action-button
                        data-cy="close-input-configuration-dialog"
                        size="x-large"
                        @click="displayInputConfigurationDialog = false"
                    >
                        Fermer
                    </s-action-button>
                </v-card-actions>
            </v-card>
        </v-form>
    </v-dialog>
</template>
